<?php
    class GSAuth extends GSBaseClass {
		protected $request_type = 'authentication';

		public function getToken() {
			$query_string = $this->gs->getUrl() .'/'. $this->request_type .'/api/'. $this->gs->getApiVersion() .'/login';
			$headers = $this->default_headers;
			$auth_username = $this->gs->getAuthUsername();
			$auth_password = $this->gs->getAuthPassword();

			if ($auth_username !== null && $auth_password !== null) {
				$headers['Authorization'] = 'Basic ' . base64_encode($auth_username . ":" . $auth_password);
			}

			$curl = GSUtils::curlRequest(
				$query_string,
				'POST',
				array(
					'scope' => json_encode(array('ManagementRestApi'))
				),
				$headers,
				array(
					"username" => $this->gs->getAuthUsername(),
					"password" => $this->gs->getAuthPassword()
				)
			);
		}
	}
?>