<?php
	require_once dirname(dirname(__DIR__)) .'/Curl/Curl.php';

	use \Curl\Curl;

    class GSUtils {
		public function __construct() {}

		public static function curlRequest($curlUrl, $requestType = 'GET', $requestData = null, $requestHeaders = array(), $auth = array()) {
			$curl = new Curl();
			$curl->setUserAgent(''); // removed default user-agent header

			if (is_array($requestHeaders) && count($requestHeaders) > 0) {
				foreach ($requestHeaders as $header_key => $header_value) {
					$curl->setHeader($header_key, $header_value);
				}
			}

			if (isset($auth['username']) && isset($auth['password'])) {
				$curl->setBasicAuthentication($auth['username'], $auth['password']);
			}

			$curl->setOpt(CURLOPT_HEADER, true);
			$curl->setOpt(CURLINFO_HEADER_OUT, true);
			$curl->setOpt(CURLOPT_RETURNTRANSFER, true);
			$curl->setOpt(CURLOPT_SSL_VERIFYPEER, false);

			switch ($requestType) {
				case 'POST':
					$curl->post($curlUrl, $requestData);
					break;
				case 'PUT':
					$curl->put($curl, $requestData);
					break;
				case 'DELETE':
					$curl->delete($curl, $requestData);
					break;
				case 'GET':
				default:
					$curl->get($curlUrl, $requestData);
					break;
			}

			// debug information
			print_r($curl->request_headers);
			print_r($requestData);
			print_r($curl->response_headers);
			print_r($curl->raw_response);

			if ($curl->error) {
				//throw new Exception('Error: ' . $curl->error_code . ': ' . $curl->error_message);
			}

			return $curl->response;
		}

		public static function parseCurlResponse($response, $response_type = 'json') {
			try {
				switch ($response_type) {
					case 'json':
						return json_decode($response, true);
						break;
					default:
						return false;
				}
			} catch (Exception $ex) {
				throw new GSException($ex->getMessage());
			}
		}

		public static function arraySortByColumn(&$arr, $col, $dir = SORT_ASC) {
			$sort_col = array();

			foreach ($arr as $key => $row) {
				$sort_col[$key] = $row[$col];
			}

			array_multisort($sort_col, $dir, $arr);
		}
	}
?> 